<?php 

################################################################################
############################## CONTACT FUNCTIONS ###############################
################################################################################

function adjustPhone($phone){
    
     writeToLog($phone, "OLD PHONES");
    
    if(!isset($phone) || $phone == ''|| trim($phone) == '+55'){
        
        return '';
        
    }
    
    $phone = trim(preg_replace('/[^0-9]/', '', $phone));
    
    if(substr($phone, 0,1) != '+'){
       $phone = '+'.$phone;
    }
    
    if(strlen($phone) == 14 ){
        return $phone;
        
    }elseif(strlen($phone) == 13 ){
        
        if(substr($phone, 0,1) == '+'){
            
            if(substr($phone, 5,1) == '7' || substr($phone, 5,1) == '8' || substr($phone, 5,1) == '9'){
                
                return substr($phone, 0,5).'9'.substr($phone, 5);
                
            }else{
            
                return $phone;
                
            }
            
        }else{
            return '+'.$phone;
        }
        
    }elseif(strlen($phone) < 13 ){
        
        if(substr($phone, 0,3) != '+55'){
            
            
            
            $phone = str_replace("+", "", $phone);
            
            if(strlen($phone) == 11){
                
                return '+55'.$phone;
                
            }elseif(strlen($phone) < 11){
                if(substr($phone, 2,1) == '7' || substr($phone, 2,1) == '8' || substr($phone, 2,1) == '9'){
                    return '+55'.substr($phone, 0,2).'9'.substr($phone, 2);
                }else{
                    return '+55'.$phone;
                }
            }else{
            
                return $phone;
            
            }
        }else{
            
            return $phone;
            
        }
        
        
        
    }else{    
        return $phone;
    }
    
}

function phonesUpdate($oldPhones, $newPhone, $type = 'WORK', $phonEmail = 'PHONE'){
    
    writeToLog($oldPhones, "OLD PHONES");
    
    if(isset($newPhone) && $newPhone != ''){
        
            $found = false;
            foreach($oldPhones as $key => $value){
                if(adjustPhone($value['VALUE']) == adjustPhone($newPhone)){
                    $found = true; 
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }else{
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => adjustPhone($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
    }else{
        return $oldPhones;
    }
    
}

function emailUpdate($oldPhones, $newPhone, $type = 'WORK'){
    
    writeToLog($oldPhones, "OLD PHONES");
    
    if(isset($newPhone) && $newPhone != ''){
    
        $found = false;
        foreach($oldPhones as $key => $value){
            if($value['VALUE'] == $newPhone){
                $found = true;        
            }
        }
        
        if($found == false){
            
            $oldPhones[] = array(
                            'VALUE_TYPE' => $type,
                            'VALUE'      => $newPhone
                );
            
        }
        
        return $oldPhones;
        
    }else{
        return $oldPhones;
    }
}

function getContactByID($id){
    
    if(isset($id) && $id != ''){

        $fields = Array('filter' => array(
                  
                                "ID" => trim($id),
                            ),
                        'SELECT' => array('ID', 'PHONE', 'EMAIL', '*', 'UF_*')
                        );
        
        $result = restCommand('crm.contact.list', $fields, AUTH);
        return $result;
    }
    
}

function getContactByFilter($filter){
    
    if(isset($filter) && $filter != ''){

        $fields = Array('filter' => array(
                '='.FILTER_CONTACT => trim($filter),
            ),
            'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL')
        );
        
        $result = restCommand('crm.contact.list', $fields, AUTH);
        return $result;
    }
    
}

function contactName($contact){
    
    $name = explode(" ", $contact);
    $firstName = $name[0];
    
    for($i = 1; $i <= sizeof($name)-1; $i++){
        $lastName .= $name[$i]." ";
    }
    
    $name = Array(
        'firstName' => $firstName,
        'lastName'  => $lastName
    );
    
    return $name;
}

function addContact($arrayContact, $ori = "contact"){
    
    if($ori == "deal"){
        
        $fields = array('fields' => array(
                            'TYPE_ID'               => 'CLIENT',
                            'UF_CRM_1597844527467'  => $arrayContact['usuario_id'],
                            'NAME'                  => "USUARIO ".$arrayContact['usuario_id'],
                            'SOURCE_ID'             => 3,    
                        ));
        
        
    }else{
    
        $ext = end(explode(".", $arrayContact['picture']));
            $photo = file_get_contents($arrayContact['picture']);
        
        $name = contactName($arrayContact['usuario_nome']);
        
        $fields = array(
    
                'fields' => array(
                    "PHOTO"                 => array("fileData" => array(time().".".$ext, base64_encode($photo))),
                    'TYPE_ID'               => 'CLIENT',
                    'UF_CRM_1597844527467'  => $arrayContact['usuario_id'],
                    'NAME'                  => $name['firstName'],
                    'SOURCE_ID'             => 3,
                    'LAST_NAME'             => $name['lastName'],
                    'UF_CRM_1589202720035'  => mask($arrayContact['usuario_cpf'], '###.###.###-##'),
                    'UF_CRM_1599785068024'  => $arrayContact['usuario_rg'],
                    'UF_CRM_1597844612747'  => $arrayContact['usuario_passaporte'],
                    'BIRTHDATE'             => $arrayContact[''],
                    'UF_CRM_1610559806498'  => $arrayContact['usuario_status'],
                    'UF_CRM_1625049634180'  => getStatus($arrayContact['usuario_status']),
                    'UF_CRM_5EB94E418C162'  => $arrayContact['informacoes_faturamento']['endereco']['logradouro'],
                    'UF_CRM_1643027746002'  => $arrayContact['informacoes_faturamento']['endereco']['numero'],
                    'UF_CRM_5EB94E419D72A'  => $arrayContact['informacoes_faturamento']['endereco']['bairro'],
                    'UF_CRM_5EB94E41ABB9F'  => $arrayContact['informacoes_faturamento']['endereco']['cep'],
                    'UF_CRM_5EB94E41B300A'  => $arrayContact['informacoes_faturamento']['endereco']['cidade'],
                    'UF_CRM_5EB94E41BA1BF'  => getState($arrayContact['informacoes_faturamento']['endereco']['estado']),
                    'UF_CRM_1597844823179'  => $arrayContact['informacoes_faturamento']['endereco']['complemento'],
                    'ADDRESS'               => $arrayContact['informacoes_faturamento']['endereco']['logradouro'].", ".$arrayContact['informacoes_faturamento']['endereco']['numero']." ".$arrayContact['informacoes_faturamento']['endereco']['complemento']." ".
                    $arrayContact['informacoes_faturamento']['endereco']['bairro']." ".$arrayContact['informacoes_faturamento']['endereco']['cidade']."/".
                    $arrayContact['informacoes_faturamento']['endereco']['estado'],
                    'EMAIL' => array(array(
                                        'VALUE' => $arrayContact['usuario_email'],
                                        'VALUE_TYPE' => 'WORK'
                                        ),
                                ),
                    'PHONE' => array(array(
                                        'VALUE' => '+55'.$arrayContact['informacoes_faturamento']['celular'],
                                        'VALUE_TYPE' => 'MOBILE'
                                        ),
                                )
                ),
    
            );
    }
        
    $contact = restCommand('crm.contact.add', $fields, AUTH);
    
    $message = "[B]TESE Prime[/B]\n";
    $message.= "Contato criado via Sistema de Provas:".$arrayContact['usuario_id'];
        
    addFeedMessage('contact', $contact['result'], $message);
    
    return $contact;
    
}

function mask($val, $mask) {
    $maskared = '';
    $k = 0;
    for($i = 0; $i<=strlen($mask)-1; $i++) {
        if($mask[$i] == '#') {
            if(isset($val[$k])) $maskared .= $val[$k++];
        } else {
            if(isset($mask[$i])) $maskared .= $mask[$i];
        }
    }
    return $maskared;
}

function updContact($contact, $arrayContact){
    
    if(isset($arrayContact['usuario_nome']) && $arrayContact['usuario_nome'] != ''){
        
        $phones = phonesUpdate($contact['result'][0]['PHONE'], $arrayContact['informacoes_faturamento']['celular'], "MOBILE");
        
        $email = emailUpdate($contact['result'][0]['EMAIL'], $arrayContact['usuario_email']);
        
        $ext = end(explode(".", $arrayContact['picture']));
        $photo = file_get_contents($arrayContact['picture']);

        $name = contactName($arrayContact['usuario_nome']);
        
        // $phone = getPhone($contact, $arrayContact['informacoes_faturamento']['celular']);
    
        $fields = Array(
    
                
                'fields' => array(
                    "PHOTO"                 => array("fileData" => array(time().".".$ext, base64_encode($photo))),
                    'TYPE_ID'               => 'CLIENT',
                    'UF_CRM_1597844527467'  => $arrayContact['usuario_id'],
                    'NAME'                  => $name['firstName'],
                    'SOURCE_ID'             => 3,
                    'LAST_NAME'             => $name['lastName'],
                    'UF_CRM_1589202720035'  =>  mask($arrayContact['usuario_cpf'], '###.###.###-##'),
                    'UF_CRM_1599785068024'  => $arrayContact['usuario_rg'],
                    'UF_CRM_1597844612747'  => $arrayContact['usuario_passaporte'],
                    'BIRTHDATE'             => $arrayContact[''],
                    'UF_CRM_1610559806498'  => $arrayContact['usuario_status'],
                    'UF_CRM_1625049634180'  => getStatus($arrayContact['usuario_status']),
                    'UF_CRM_5EB94E418C162'  => $arrayContact['informacoes_faturamento']['endereco']['logradouro'],
                    'UF_CRM_1643027746002'  => $arrayContact['informacoes_faturamento']['endereco']['numero'],
                    'UF_CRM_5EB94E419D72A'  => $arrayContact['informacoes_faturamento']['endereco']['bairro'],
                    'UF_CRM_5EB94E41ABB9F'  => $arrayContact['informacoes_faturamento']['endereco']['cep'],
                    'UF_CRM_5EB94E41B300A'  => $arrayContact['informacoes_faturamento']['endereco']['cidade'],
                    'UF_CRM_5EB94E41BA1BF'  => getState($arrayContact['informacoes_faturamento']['endereco']['estado']),
                    'UF_CRM_1597844823179'  => $arrayContact['informacoes_faturamento']['endereco']['complemento'],
                    'ADDRESS'               => $arrayContact['informacoes_faturamento']['endereco']['logradouro'].", ".$arrayContact['informacoes_faturamento']['endereco']['numero']." ".$arrayContact['informacoes_faturamento']['endereco']['complemento']." ".
                $arrayContact['informacoes_faturamento']['endereco']['bairro']." ".$arrayContact['informacoes_faturamento']['endereco']['cidade']."/".
                $arrayContact['informacoes_faturamento']['endereco']['estado'],
                    'EMAIL' => $email, /*array(array(
                                        'VALUE' => $arrayContact['usuario_email'],
                                        'VALUE_TYPE' => 'WORK'
                                        ),
                                ),*/
                    'PHONE' => $phones, /*array(array(
                                        'VALUE' => '+55'.$arrayContact['informacoes_faturamento']['celular'],
                                        'VALUE_TYPE' => 'MOBILE'
                                        ),
                                )*/
                ),
                'ID' => $contact['result'][0]['ID']
            );
            
            writeToLog($fields, "Update Contact");
        
        $contactUpd = restCommand('crm.contact.update', $fields, AUTH);
        
        $message = "[B]TESE Prime[/B]\n";
        $message.= "Contato atualizado via Sistema de Provas";
        
        addFeedMessage('contact', $contact['result'][0]['ID'], $message);
    }
    
}

function getPhone($contact, $tel1){
    
    $phone = array();
    $p = array();
    $i = 0;
    
    foreach($contact['result'][0]['PHONE'] as $key => $value){
        $p[$i] = $value['ID'];
        $i++;
    }
    
    if($tel1 != ""){
        $phone[0]['ID']         = $p[0];
        $phone[0]['VALUE_TYPE'] = "HOME";
        $phone[0]['VALUE']      = $tel1;
        $phone[0]['TYPE_ID']    = "PHONE";    
    }
    
    return $phone;
}

function getEmail($contact, $email1){
    
    $email = array();
    $p = array();
    $i = 0;
    
    foreach($contact['result'][0]['EMAIL'] as $key => $value){
        $p[$i] = $value['ID'];
        $i++;
    }
    
    if($email1 != ""){
        $email[0]['ID']         = $p[0];
        $email[0]['VALUE_TYPE'] = "WORK";
        $email[0]['VALUE']      = $email1;
        $email[0]['TYPE_ID']    = "EMAIL";    
    }
    
    return $email;
}

function getState($state){
    $array = array(
        "AC" => "99",
        "AL" => "101",
        "AP" => "103",
        "AM" => "105",
        "BA" => "107",
        "CE" => "109",
        "DF" => "111",
        "ES" => "113",
        "GO" => "115",
        "MA" => "117",
        "MT" => "119",
        "MS" => "121",
        "MG" => "123",
        "PA" => "125",
        "PB" => "127",
        "PR" => "129",
        "PE" => "131",
        "PI" => "133",
        "RJ" => "135",
        "RN" => "137",
        "RS" => "139",
        "RO" => "141",
        "RR" => "143",
        "SC" => "145",
        "SP" => "147",
        "SE" => "149",
        "TO" => "151"
    );
    return $array[$state];
}

function getStatus($status){
    
    $array = array(
        "Ativo" => "1164",
        "Inativo" => "1166",
        );
    return $array[$status];
    
    
}

?>